Index: winamp-musepack/trunk/winamp-musepack/winamp-musepack.vcproj
===================================================================
--- winamp-musepack/trunk/winamp-musepack/winamp-musepack.vcproj	(revision 189)
+++ winamp-musepack/trunk/winamp-musepack/winamp-musepack.vcproj	(revision 191)
@@ -5,4 +5,5 @@
 	Name="winamp-musepack"
 	ProjectGUID="{EEA7D671-FB86-4E8D-8F1A-CC05174342F0}"
+	RootNamespace="winamp-musepack"
 	>
 	<Platforms>
@@ -40,4 +41,6 @@
 				AdditionalIncludeDirectories="..\..\libmpc\include;C:\Program Files\taglib\include\taglib"
 				PreprocessorDefinitions="_CRT_SECURE_NO_DEPRECATE"
+				RuntimeLibrary="2"
+				WarningLevel="3"
 				DebugInformationFormat="1"
 			/>
@@ -56,6 +59,7 @@
 				OutputFile="E:\Program Files\Winamp\Plugins\in_mpc.dll"
 				AdditionalLibraryDirectories="..\..\libmpc\win32\Debug;C:\Program Files\taglib\lib"
+				GenerateManifest="false"
 				IgnoreAllDefaultLibraries="false"
-				IgnoreDefaultLibraryNames="LIBCMTD;MSVCRT"
+				IgnoreDefaultLibraryNames="LIBCMTD;MSVCRT;MSVCMRT"
 				GenerateDebugInformation="true"
 			/>
@@ -87,6 +91,7 @@
 		<Configuration
 			Name="Release|Win32"
+			OutputDirectory="$(SolutionDir)$(ConfigurationName)"
 			IntermediateDirectory="$(ConfigurationName)"
-			ConfigurationType="1"
+			ConfigurationType="2"
 			>
 			<Tool
@@ -107,4 +112,8 @@
 			<Tool
 				Name="VCCLCompilerTool"
+				AdditionalIncludeDirectories="..\..\libmpc\include;C:\Program Files\taglib\include\taglib"
+				PreprocessorDefinitions="_CRT_SECURE_NO_DEPRECATE"
+				RuntimeLibrary="2"
+				WarningLevel="1"
 			/>
 			<Tool
@@ -119,4 +128,9 @@
 			<Tool
 				Name="VCLinkerTool"
+				AdditionalDependencies="User32.lib libmpcdec.lib libcommon.lib tag.lib"
+				OutputFile="E:\Program Files\Winamp\Plugins\in_mpc.dll"
+				AdditionalLibraryDirectories="..\..\libmpc\win32\Release;C:\Program Files\taglib\lib"
+				GenerateManifest="true"
+				IgnoreDefaultLibraryNames="LIBCMT"
 			/>
 			<Tool
@@ -147,4 +161,24 @@
 	</Configurations>
 	<References>
+		<AssemblyReference
+			RelativePath="System.dll"
+			AssemblyName="System, Version=2.0.0.0, PublicKeyToken=b77a5c561934e089, processorArchitecture=MSIL"
+		/>
+		<AssemblyReference
+			RelativePath="System.Data.dll"
+			AssemblyName="System.Data, Version=2.0.0.0, PublicKeyToken=b77a5c561934e089, processorArchitecture=x86"
+		/>
+		<AssemblyReference
+			RelativePath="System.Drawing.dll"
+			AssemblyName="System.Drawing, Version=2.0.0.0, PublicKeyToken=b03f5f7f11d50a3a, processorArchitecture=MSIL"
+		/>
+		<AssemblyReference
+			RelativePath="System.Windows.Forms.dll"
+			AssemblyName="System.Windows.Forms, Version=2.0.0.0, PublicKeyToken=b77a5c561934e089, processorArchitecture=MSIL"
+		/>
+		<AssemblyReference
+			RelativePath="System.XML.dll"
+			AssemblyName="System.Xml, Version=2.0.0.0, PublicKeyToken=b77a5c561934e089, processorArchitecture=MSIL"
+		/>
 	</References>
 	<Files>
@@ -159,6 +193,54 @@
 			</File>
 			<File
+				RelativePath=".\mpc_info.cpp"
+				>
+				<FileConfiguration
+					Name="Debug|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						MinimalRebuild="false"
+						ExceptionHandling="2"
+						BasicRuntimeChecks="0"
+						UsePrecompiledHeader="0"
+						DebugInformationFormat="3"
+						CompileAsManaged="1"
+					/>
+				</FileConfiguration>
+				<FileConfiguration
+					Name="Release|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						MinimalRebuild="false"
+						ExceptionHandling="2"
+						BasicRuntimeChecks="0"
+						UsePrecompiledHeader="0"
+						DebugInformationFormat="3"
+						CompileAsManaged="1"
+					/>
+				</FileConfiguration>
+			</File>
+			<File
 				RelativePath=".\mpc_player.cpp"
 				>
+				<FileConfiguration
+					Name="Debug|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						ExceptionHandling="2"
+						CompileAsManaged="1"
+					/>
+				</FileConfiguration>
+				<FileConfiguration
+					Name="Release|Win32"
+					>
+					<Tool
+						Name="VCCLCompilerTool"
+						ExceptionHandling="2"
+						CompileAsManaged="1"
+					/>
+				</FileConfiguration>
 			</File>
 		</Filter>
@@ -173,4 +255,14 @@
 			</File>
 			<File
+				RelativePath=".\mpc_info.h"
+				FileType="3"
+				>
+				<File
+					RelativePath=".\mpc_info.resx"
+					SubType="Designer"
+					>
+				</File>
+			</File>
+			<File
 				RelativePath=".\mpc_player.h"
 				>