Index: libmpc/branches/r2d/win32/libcommon.vcproj
===================================================================
--- libmpc/branches/r2d/win32/libcommon.vcproj	(revision 194)
+++ libmpc/branches/r2d/win32/libcommon.vcproj	(revision 287)
@@ -77,4 +77,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
+				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
 			/>
 		</Configuration>
@@ -138,4 +139,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
+				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
 			/>
 		</Configuration>
@@ -154,5 +156,5 @@
 			</File>
 			<File
-				RelativePath="..\common\huffman.c"
+				RelativePath="..\common\huffman-bcl.c"
 				>
 			</File>
Index: libmpc/branches/r2d/win32/libmpcdec.vcproj
===================================================================
--- libmpc/branches/r2d/win32/libmpcdec.vcproj	(revision 194)
+++ libmpc/branches/r2d/win32/libmpcdec.vcproj	(revision 287)
@@ -79,5 +79,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
-				CommandLine="copy $(TargetPath) ..\bin\."
+				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
 			/>
 		</Configuration>
@@ -142,5 +142,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
-				CommandLine="copy $(TargetPath) ..\bin\."
+				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
 			/>
 		</Configuration>
@@ -165,5 +165,9 @@
 			</File>
 			<File
-				RelativePath="..\libmpcdec\math.h"
+				RelativePath="..\libmpcdec\mpc_bits_reader.h"
+				>
+			</File>
+			<File
+				RelativePath="..\libmpcdec\mpcdec_math.h"
 				>
 			</File>
@@ -213,17 +217,29 @@
 			>
 			<File
+				RelativePath="..\include\mpc\datatypes.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\mpc\minimax.h"
+				>
+			</File>
+			<File
 				RelativePath="..\include\mpc\mpc_types.h"
 				>
 			</File>
 			<File
-				RelativePath="..\include\mpcdec\mpcdec.h"
-				>
-			</File>
-			<File
-				RelativePath="..\include\mpcdec\reader.h"
-				>
-			</File>
-			<File
-				RelativePath="..\include\mpcdec\streaminfo.h"
+				RelativePath="..\include\mpc\mpcdec.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\mpc\mpcmath.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\mpc\reader.h"
+				>
+			</File>
+			<File
+				RelativePath="..\include\mpc\streaminfo.h"
 				>
 			</File>
Index: libmpc/branches/r2d/win32/libmpcenc.vcproj
===================================================================
--- libmpc/branches/r2d/win32/libmpcenc.vcproj	(revision 194)
+++ libmpc/branches/r2d/win32/libmpcenc.vcproj	(revision 287)
@@ -47,5 +47,5 @@
 				WarningLevel="3"
 				Detect64BitPortabilityProblems="true"
-				DebugInformationFormat="4"
+				DebugInformationFormat="1"
 				CompileAs="1"
 			/>
@@ -77,4 +77,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
+				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
 			/>
 		</Configuration>
@@ -138,4 +139,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
+				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
 			/>
 		</Configuration>
Index: libmpc/branches/r2d/win32/libmpcpsy.vcproj
===================================================================
--- libmpc/branches/r2d/win32/libmpcpsy.vcproj	(revision 194)
+++ libmpc/branches/r2d/win32/libmpcpsy.vcproj	(revision 287)
@@ -77,4 +77,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
+				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
 			/>
 		</Configuration>
@@ -140,4 +141,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
+				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
 			/>
 		</Configuration>
Index: libmpc/branches/r2d/win32/libwavformat.vcproj
===================================================================
--- libmpc/branches/r2d/win32/libwavformat.vcproj	(revision 194)
+++ libmpc/branches/r2d/win32/libwavformat.vcproj	(revision 287)
@@ -79,5 +79,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
-				CommandLine="copy $(TargetPath) ..\bin\."
+				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
 			/>
 		</Configuration>
@@ -143,5 +143,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
-				CommandLine="copy $(TargetPath) ..\bin\."
+				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
 			/>
 		</Configuration>
Index: libmpc/branches/r2d/win32/mpcdec.vcproj
===================================================================
--- libmpc/branches/r2d/win32/mpcdec.vcproj	(revision 194)
+++ libmpc/branches/r2d/win32/mpcdec.vcproj	(revision 287)
@@ -96,5 +96,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
-				CommandLine="copy $(TargetPath) ..\bin\."
+				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
 			/>
 		</Configuration>
@@ -178,5 +178,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
-				CommandLine="copy $(TargetPath) ..\bin\."
+				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
 			/>
 		</Configuration>
Index: libmpc/branches/r2d/win32/mpcenc.vcproj
===================================================================
--- libmpc/branches/r2d/win32/mpcenc.vcproj	(revision 194)
+++ libmpc/branches/r2d/win32/mpcenc.vcproj	(revision 287)
@@ -2,5 +2,5 @@
 <VisualStudioProject
 	ProjectType="Visual C++"
-	Version="8.00"
+	Version="8,00"
 	Name="mpcenc"
 	ProjectGUID="{15082E34-9324-469F-8423-F995B4814A37}"
@@ -96,5 +96,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
-				CommandLine="copy $(TargetPath) ..\bin"
+				CommandLine="copy &quot;$(TargetPath)&quot; ..\bin"
 			/>
 		</Configuration>
@@ -178,5 +178,5 @@
 			<Tool
 				Name="VCPostBuildEventTool"
-				CommandLine="copy $(TargetPath) ..\bin"
+				CommandLine="copy &quot;$(TargetPath)&quot; ..\binbin"
 			/>
 		</Configuration>